-- 
--   

USE {Variable_TempDb}
GO

IF not exists(select * from sysobjects where id = object_id('[dbo].[__ACCOUNTS_SMETA_KS]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[__ACCOUNTS_SMETA_KS] (
	[LINK_NEW] int ,
	[LINK_OLD] INT )
ELSE 
	DELETE FROM [dbo].[__ACCOUNTS_SMETA_KS]
GO

IF not exists(select * from sysobjects where id = object_id('[dbo].[__ACCOUNTS_TREASURY_SMETA_KS]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[__ACCOUNTS_TREASURY_SMETA_KS] (
	[LINK_NEW] int ,
	[LINK_OLD] INT )
ELSE 
	DELETE FROM [dbo].[__ACCOUNTS_TREASURY_SMETA_KS]
GO

set xact_abort on
BEGIN TRAN


IF Exists(select 1 from {Variable_WorkDb}.sys.columns where Name = N'LINK_OLD' and Object_ID = Object_ID(N'[{Variable_WorkDb}].[dbo].DEPARTMENT_ACCOUNTS'))
	BEGIN
	   ALTER TABLE [{Variable_WorkDb}].[dbo].DEPARTMENT_ACCOUNTS DROP COLUMN [LINK_OLD]
	END
GO
 ALTER TABLE [{Variable_WorkDb}].[dbo].DEPARTMENT_ACCOUNTS ADD [LINK_OLD] INT NULL
GO

DECLARE @iError int

/*****************************  *****************************/
IF OBJECT_ID('TEMPDB..#TAB1','U') IS NOT NULL
	DROP TABLE #TAB1

---       
SELECT DISTINCT
	CODE        = ISNULL(LEFT(LTRIM(RTRIM( da.CODE {WORK_COLLATE} )),20),''),
	[TYPE]      = da.[TYPE],
	DEP         = isnull(dbks.LINK_NEW,b2.LINK),
	ACC         = NULL,
	LINK_UP     = dsks.LINK_NEW,
	[LINK_OLD]  = da.LINK
INTO #TAB1	
FROM 
	{Variable_SmetaDb}.dbo.DEPARTMENT_ACCOUNTS da
	INNER JOIN {Variable_SmetaDb}.dbo.BANKS b ON b.LINK = da.BANK_LINK
	INNER JOIN [{Variable_TempDb}].dbo.[__DEPARTMENTS_BANKS_SMETA_KS] dbks ON dbks.LINK_OLD = da.BANK_LINK
	INNER JOIN [{Variable_TempDb}].dbo.[__DEPARTMENTS_SMETA_KS] dsks ON dsks.LINK_OLD = da.LINK_UP
	LEFT JOIN 
	(
		SELECT D11.LINK, RIGHT(B11.BIK,9) AS BIK 
		FROM {Variable_WorkDb}.dbo.DEPARTMENTS D11 INNER JOIN {Variable_WorkDb}.dbo.BANKS B11 ON B11.LINK = D11.LINK
		WHERE D11.LINK_DEP = [{Variable_WorkDb}].dbo.GetSaveDictDepLink('DICTIONARY_BANK', {LINK_DEP_MAIN}) /*  */
	) b2 ON b2.BIK = RIGHT(b.BIK {WORK_COLLATE},9)

---  ,  
INSERT INTO [{Variable_TempDb}].dbo.[__ACCOUNTS_SMETA_KS] ([LINK_NEW], [LINK_OLD])
SELECT DISTINCT
	[LINK_NEW] = DA.LINK,
	S.[LINK_OLD]
FROM 
	#TAB1 S
	INNER JOIN 
		(
			SELECT LINK, LINK_UP, DEP, CODE, NUM = ROW_NUMBER() OVER (PARTITION BY LINK_UP, DEP, CODE ORDER BY LINK)
			FROM 
				[{Variable_WorkDb}].dbo.DEPARTMENT_ACCOUNTS
			WHERE
				[TYPE] = 1
		) DA ON DA.NUM = 1 AND DA.LINK_UP = S.LINK_UP AND DA.DEP = S.DEP AND DA.CODE = S.CODE

WHERE 
	S.DEP IS NOT NULL
	AND S.LINK_UP IS NOT NULL
	AND S.CODE <> ''

---  ,   
INSERT INTO [{Variable_WorkDb}].dbo.DEPARTMENT_ACCOUNTS WITH (ROWLOCK) (CODE,[TYPE],DEP,ACC,LINK_UP,[LINK_OLD])
OUTPUT INSERTED.LINK,INSERTED.[LINK_OLD]
	INTO [{Variable_TempDb}].dbo.[__ACCOUNTS_SMETA_KS]
SELECT DISTINCT
	CODE, 
	[TYPE],
	DEP,
	ACC,
	LINK_UP,
	[LINK_OLD]
FROM 
	#TAB1 S
WHERE
	NOT EXISTS (SELECT * FROM [{Variable_TempDb}].dbo.[__ACCOUNTS_SMETA_KS] T WHERE T.[LINK_OLD] = S.[LINK_OLD])
	AND S.DEP IS NOT NULL
	AND S.LINK_UP IS NOT NULL

DECLARE @iROWCOUNT1 INT
SET @iROWCOUNT1 = @@ROWCOUNT

SELECT @iError = @@ERROR
IF @iError <> 0
BEGIN
	ROLLBACK
END

/*****************************  *****************************/
IF OBJECT_ID('TEMPDB..#TAB2','U') IS NOT NULL
	DROP TABLE #TAB2

---     
SELECT DISTINCT
	CODE        = ISNULL(LEFT(LTRIM(RTRIM( ta.CODE {WORK_COLLATE} )),20),''),
	[TYPE]      = 1,
	DEP         = isnull(d.LINK,b2.LINK),
	ACC         = NULL,
	LINK_UP     = tsks.LINK_NEW,
	[LINK_OLD]  = ta.LINK
INTO #TAB2	
FROM 
	{Variable_SmetaDb}.dbo.TREASURY_ACCOUNTS ta
	INNER JOIN [{Variable_TempDb}].dbo.[__TREASURY_SMETA_KS] tsks ON tsks.LINK_OLD = ta.LINK_UP

	LEFT JOIN [{Variable_TempDb}].dbo.[__DEPARTMENTS_BANKS_SMETA_KS] dbks ON dbks.LINK_OLD = ta.BANK_LINK
	LEFT JOIN [{Variable_WorkDb}].dbo.DEPARTMENTS d ON d.LINK = dbks.LINK_NEW AND d.LINK_DEP = [{Variable_WorkDb}].dbo.GetSaveDictDepLink('DICTIONARY_BANK', {LINK_DEP_MAIN}) /*  */
	LEFT JOIN {Variable_SmetaDb}.dbo.BANKS b ON b.LINK = ta.BANK_LINK
	LEFT JOIN 
	(
		SELECT D11.LINK, RIGHT(B11.BIK,9) AS BIK 
		FROM {Variable_WorkDb}.dbo.DEPARTMENTS D11 INNER JOIN {Variable_WorkDb}.dbo.BANKS B11 ON B11.LINK = D11.LINK
		WHERE D11.LINK_DEP = [{Variable_WorkDb}].dbo.GetSaveDictDepLink('DICTIONARY_BANK', {LINK_DEP_MAIN}) /*  */
	) b2 ON b2.BIK = RIGHT(b.BIK {WORK_COLLATE},9)

---  ,  
INSERT INTO [{Variable_TempDb}].dbo.[__ACCOUNTS_TREASURY_SMETA_KS] ([LINK_NEW], [LINK_OLD])
SELECT DISTINCT
	[LINK_NEW] = DA.LINK,
	S.[LINK_OLD]
FROM 
	#TAB2 S
	INNER JOIN 
		(
			SELECT LINK, LINK_UP, DEP, CODE, NUM = ROW_NUMBER() OVER (PARTITION BY LINK_UP, DEP, CODE ORDER BY LINK)
			FROM 
				[{Variable_WorkDb}].dbo.DEPARTMENT_ACCOUNTS
			WHERE
				[TYPE] = 1
		) DA ON DA.NUM = 1 AND DA.LINK_UP = S.LINK_UP AND DA.DEP = S.DEP AND DA.CODE = S.CODE

WHERE 
	S.DEP IS NOT NULL
	AND S.LINK_UP IS NOT NULL
	AND S.CODE <> ''

---  ,   
INSERT INTO [{Variable_WorkDb}].dbo.DEPARTMENT_ACCOUNTS WITH (ROWLOCK) (CODE,[TYPE],DEP,ACC,LINK_UP,[LINK_OLD])
OUTPUT INSERTED.LINK,INSERTED.[LINK_OLD]
	INTO [{Variable_TempDb}].dbo.[__ACCOUNTS_TREASURY_SMETA_KS]
SELECT DISTINCT
	CODE, 
	[TYPE],
	DEP,
	ACC,
	LINK_UP,
	[LINK_OLD]
FROM 
	#TAB2 S
WHERE
	NOT EXISTS (SELECT * FROM [{Variable_TempDb}].dbo.[__ACCOUNTS_TREASURY_SMETA_KS] T WHERE T.[LINK_OLD] = S.[LINK_OLD])
	AND S.DEP IS NOT NULL
	AND S.LINK_UP IS NOT NULL

SET @iROWCOUNT1 = @@ROWCOUNT + @iROWCOUNT1

SELECT @iError = @@ERROR
IF @iError <> 0
BEGIN
	ROLLBACK
END

/***************************** *****************************/

IF OBJECT_ID('TEMPDB..#TAB3','U') IS NOT NULL
	DROP TABLE #TAB3

---   
SELECT DISTINCT
	CODE        = ISNULL(LEFT(LTRIM(RTRIM(da.CODE {WORK_COLLATE} )),11),''),
	[TYPE]      = 2,
	DEP         = NULL,
	ACC         = asks.LINK_NEW,
	LINK_UP     = dsks.LINK_NEW,
	[LINK_OLD]  = da.LINK
INTO
	#TAB3	
FROM 
	{Variable_SmetaDb}.dbo.DEPARTMENT_ACCOUNTS da
	INNER JOIN [{Variable_TempDb}].dbo.[__ACCOUNTS_TREASURY_SMETA_KS] asks ON asks.LINK_OLD = da.TA_LINK
	INNER JOIN [{Variable_TempDb}].dbo.[__DEPARTMENTS_SMETA_KS] dsks ON dsks.LINK_OLD = da.LINK_UP

---  ,  
INSERT INTO [{Variable_TempDb}].dbo.[__ACCOUNTS_SMETA_KS] ([LINK_NEW], [LINK_OLD])
SELECT DISTINCT
	[LINK_NEW] = DA.LINK,
	S.[LINK_OLD]
FROM 
	#TAB3 S
	INNER JOIN 
		(
			SELECT LINK, LINK_UP, ACC, CODE, NUM = ROW_NUMBER() OVER (PARTITION BY LINK_UP, ACC, CODE ORDER BY LINK)
			FROM 
				[{Variable_WorkDb}].dbo.DEPARTMENT_ACCOUNTS
			WHERE
				[TYPE] = 2
		) DA ON DA.NUM = 1 AND DA.LINK_UP = S.LINK_UP AND DA.CODE = S.CODE AND DA.ACC = S.ACC
WHERE 
	S.ACC IS NOT NULL
	AND S.LINK_UP IS NOT NULL
	AND S.CODE <> ''

---  ,   
INSERT INTO [{Variable_WorkDb}].dbo.DEPARTMENT_ACCOUNTS WITH (ROWLOCK) (CODE,[TYPE],DEP,ACC,LINK_UP,[LINK_OLD])
OUTPUT INSERTED.LINK,INSERTED.[LINK_OLD]
	INTO [{Variable_TempDb}].dbo.[__ACCOUNTS_SMETA_KS]
SELECT DISTINCT
	CODE, 
	[TYPE],
	DEP,
	ACC,
	LINK_UP,
	[LINK_OLD]
FROM 
	#TAB3 S
WHERE
	NOT EXISTS (SELECT * FROM [{Variable_TempDb}].dbo.[__ACCOUNTS_SMETA_KS] T WHERE T.[LINK_OLD] = S.[LINK_OLD])
	AND S.ACC IS NOT NULL
	AND S.LINK_UP IS NOT NULL
	AND S.CODE <> ''

DECLARE @iROWCOUNT2 INT
SET @iROWCOUNT2 = @@ROWCOUNT

SELECT @iError = @@ERROR
IF @iError <> 0
BEGIN
	ROLLBACK
END
---

UPDATE [{Variable_WorkDb}].dbo.DEPARTMENT_ACCOUNTS SET CODE = LTRIM(RTRIM(CODE)) WHERE CHARINDEX(' ', CODE) > 0
 
--    
INSERT INTO [{Variable_TempDb}].dbo.[__Journal]
VALUES (' " (-)"', '  : ' + convert(nvarchar(100),@iROWCOUNT1) + ',  : ' + convert(nvarchar(100),@iROWCOUNT2), '', 0)
--

ALTER TABLE [{Variable_WorkDb}].[dbo].DEPARTMENT_ACCOUNTS DROP COLUMN [LINK_OLD]
GO

COMMIT TRAN
