
set xact_abort on
BEGIN TRAN
-- 
--   
USE {Variable_TempDb}
GO
IF not exists(select * from sysobjects where id = object_id('[dbo].[__NOMENCLATURE_SMETA_KS]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[__NOMENCLATURE_SMETA_KS] (
	[LINK_NEW] int ,
	[LINK_OLD] INT )
ELSE 
	DELETE FROM [dbo].[__NOMENCLATURE_SMETA_KS]

GO

IF Exists(select 1 from {Variable_WorkDb}.sys.columns where Name = N'LINK_OLD' and Object_ID = Object_ID(N'[{Variable_WorkDb}].[dbo].NOMENCLATURE'))
	BEGIN
	   ALTER TABLE [{Variable_WorkDb}].[dbo].NOMENCLATURE DROP COLUMN [LINK_OLD]
	END
GO
 ALTER TABLE [{Variable_WorkDb}].[dbo].NOMENCLATURE ADD [LINK_OLD] INT NULL
GO

--    ,  
DECLARE @iLINK_UNKNOWN_GROUP INT
SELECT TOP 1 @iLINK_UNKNOWN_GROUP = ga.LINK FROM [{Variable_WorkDb}].dbo.GROUP_ACTIVE ga WHERE ga.CODE_GRP = '00000'

IF OBJECT_ID('TEMPDB..#TAB1','U') IS NOT NULL
	DROP TABLE #TAB1

SELECT 
    CODE        = RIGHT(LTRIM(RTRIM(n.CODE {WORK_COLLATE})),20),
    [NAME]      = LTRIM(RTRIM(n.NAME {WORK_COLLATE})),
    GROUP_INV   = COALESCE(
					(SELECT TOP 1 LINK_NEW FROM [{Variable_TempDb}].dbo.[__GROUP_ACTIVE_SMETA_KS] WHERE LINK_OLD = n.GROUP_INV),
					(SELECT TOP 1 LINK FROM [{Variable_WorkDb}].dbo.GROUP_ACTIVE ga WHERE ga.ACCOUNT_B = sa2.LINK),
					@iLINK_UNKNOWN_GROUP
					),
    UM          = ISNULL(msks.LINK_NEW,(SELECT TOP 1 LINK FROM [{Variable_WorkDb}].dbo.MEASURE WHERE CODE = RIGHT(d.CODE {WORK_COLLATE},5))),
    SERIES      = n.SERIES,
    IS_EXTRA    = n.IS_EXTRA,
    LINK_OKDP   = NULL,
    COEFF       = n.COEFF,
    PRICE_TYPE  = n.PRICE_TYPE,
    ISUSED      = n.ISUSED,
    LINK_DEP    = {LINK_DEP_MAIN},
    LINK_OLD    = n.LINK
INTO
	#TAB1
FROM 
	{Variable_SmetaDb}.dbo.NOMENCLATURE n
	LEFT JOIN {Variable_SmetaDb}.dbo.GROUP_INV gi ON gi.LINK = n.GROUP_INV
	LEFT JOIN {Variable_SmetaDb}.dbo.S_ACCOUNTS sa ON sa.LINK = gi.ACCOUNT
	LEFT JOIN [{Variable_WorkDb}].dbo.S_ACCOUNTS sa2 ON sa2.CODE = sa.CODE {WORK_COLLATE} AND sa2.LINK_DEP = [{Variable_WorkDb}].dbo.getOwnDepLink()
	LEFT JOIN [{Variable_TempDb}].dbo.[__MEASURE_SMETA_KS] msks ON msks.LINK_OLD = n.UM
	LEFT JOIN {Variable_SmetaDb}.dbo.DICTION d ON d.LINK = n.UM

---  ,  
INSERT INTO [{Variable_TempDb}].dbo.[__NOMENCLATURE_SMETA_KS] ([LINK_NEW], [LINK_OLD])
SELECT DISTINCT
	[LINK_NEW] = N.LINK, 
	T.LINK_OLD
FROM 
	#TAB1 T
	INNER JOIN 
	(	
	SELECT LINK, [GROUP_INV], [NAME],
		NUM = ROW_NUMBER() OVER (PARTITION BY [GROUP_INV], [NAME] ORDER BY [GROUP_INV], [NAME])
	FROM 
		{Variable_WorkDb}.dbo.NOMENCLATURE
	WHERE 
		[LINK_DEP] = {LINK_DEP_MAIN}
	) N ON N.[GROUP_INV] = T.[GROUP_INV] AND N.[NAME] = T.[NAME]
WHERE
	N.NUM = 1

---  ,   
INSERT INTO [{Variable_WorkDb}].dbo.NOMENCLATURE
	(CODE, [NAME], GROUP_INV, UM, SERIES, IS_EXTRA, LINK_OKDP, COEFF, PRICE_TYPE, ISUSED, LINK_DEP, [LINK_OLD])
OUTPUT INSERTED.LINK,INSERTED.[LINK_OLD] 
    INTO [{Variable_TempDb}].dbo.[__NOMENCLATURE_SMETA_KS]
SELECT 
    [CODE],
    [NAME],
    [GROUP_INV],
    [UM],
    [SERIES],
	[IS_EXTRA],
    [LINK_OKDP],
    [COEFF],
    ISNULL([PRICE_TYPE],0),
    [ISUSED],
    [LINK_DEP],
    [LINK_OLD]
FROM 
	#TAB1 A
WHERE	
	NOT EXISTS (SELECT * FROM [{Variable_TempDb}].dbo.[__NOMENCLATURE_SMETA_KS] T WHERE T.[LINK_OLD] = A.[LINK_OLD])

DECLARE @iROWS_COPIED BIGINT
SET @iROWS_COPIED = @@ROWCOUNT

INSERT INTO [{Variable_TempDb}].dbo.[__Journal]
VALUES (' " (-)"', ' : ' + convert(nvarchar(100),@iROWS_COPIED), '', 0)

ALTER TABLE [{Variable_WorkDb}].[dbo].NOMENCLATURE DROP COLUMN [LINK_OLD]
GO

UPDATE n
SET n.GROUP_INV = ga.LINK_SELF
FROM 
	[{Variable_WorkDb}].dbo.NOMENCLATURE n
	INNER JOIN [{Variable_TempDb}].dbo.[__NOMENCLATURE_SMETA_KS] nn ON nn.LINK_NEW = n.LINK
	INNER JOIN [{Variable_WorkDb}].dbo.GROUP_ACTIVE ga ON ga.LINK = n.GROUP_INV
WHERE 
	ga.LINK_SELF IS NOT NULL


COMMIT TRAN