
set xact_abort on
BEGIN TRAN
---   ---
--   
USE {Variable_TempDb}
GO
IF not exists(select * from sysobjects where id = object_id('[dbo].[__PLACEMENTS_SMETA_KS]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[__PLACEMENTS_SMETA_KS] (
	[LINK_NEW] int ,
	[LINK_OLD] INT )
ELSE 
	DELETE FROM [dbo].[__PLACEMENTS_SMETA_KS]
	
IF Exists(select 1 from {Variable_WorkDb}.sys.columns where Name = N'LINK_OLD' and Object_ID = Object_ID(N'[{Variable_WorkDb}].[dbo].[PLACEMENTS]'))
	BEGIN
	   ALTER TABLE [{Variable_WorkDb}].[dbo].[PLACEMENTS] DROP COLUMN [LINK_OLD]
	END
GO
 ALTER TABLE [{Variable_WorkDb}].[dbo].[PLACEMENTS] ADD [LINK_OLD] INT NULL
GO

INSERT INTO [{Variable_WorkDb}].dbo.PLACEMENTS
	(CODE, [NAME], EMPL, LINK_DEP, LINK_OLD)
OUTPUT INSERTED.LINK, INSERTED.LINK_OLD
	INTO [{Variable_TempDb}].[dbo].[__PLACEMENTS_SMETA_KS]
SELECT
	p.CODE,
	p.NAME,
	EMPL        = esk.LINK_NEW,
	LINK_DEP    = {LINK_DEP_MAIN},
	LINK_OLD    = p.LINK
FROM {Variable_SmetaDb}.dbo.PLACEMENTS p
	LEFT JOIN 
	(	SELECT RowNumber = ROW_NUMBER () OVER ( PARTITION BY LINK_OLD ORDER BY LINK_OLD), *
		FROM [{Variable_TempDb}].dbo.__EMPL_SMETA_KS) esk ON  esk.LINK_OLD = p.EMPL
		WHERE (esk.RowNumber = 1 OR esk.RowNumber IS NULL
	)


 ALTER TABLE [{Variable_WorkDb}].[dbo].[PLACEMENTS] DROP COLUMN [LINK_OLD]
GO
COMMIT TRAN

BEGIN TRAN
---  ---
DECLARE @iOBJECT_OS INT
SELECT @iOBJECT_OS = LINK FROM [{Variable_WorkDb}].dbo.S_OBJECTS so
WHERE so.CODE = 'INVENTORY_CARD'

IF Exists(select 1 from {Variable_WorkDb}.sys.columns where Name = N'LINK_OLD' and Object_ID = Object_ID(N'[{Variable_WorkDb}].[dbo].[INVENTORY]'))
	BEGIN
	   ALTER TABLE [{Variable_WorkDb}].[dbo].[INVENTORY] DROP COLUMN [LINK_OLD]
	END
GO
 ALTER TABLE [{Variable_WorkDb}].[dbo].[INVENTORY] ADD [LINK_OLD] INT NULL
GO

--   
USE {Variable_TempDb}
GO
	
IF not exists(select * from sysobjects where id = object_id('[dbo].[__INVENTORY_SMETA_KS]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[__INVENTORY_SMETA_KS] (
	[LINK_NEW] int ,
	[LINK_OLD] INT )
ELSE 
	DELETE FROM [dbo].[__INVENTORY_SMETA_KS]


DECLARE @iROWCOUNT INT
SET @iROWCOUNT = 0
---  
INSERT INTO [{Variable_WorkDb}].dbo.[INVENTORY] 
   ([CODE], 
   [NAME], 
   [COST], 
   [COMMENTS], 
   [STOCK], 
   [DEP_LINK],
   [NOMENCLATURE],
   [TYPE_INV],
   [ATTACH],
   [LINK_OLD])
OUTPUT INSERTED.LINK, INSERTED.LINK_OLD
	INTO [{Variable_TempDb}].[dbo].[__INVENTORY_SMETA_KS]
SELECT 
	[CODE]          = isnull(right(LTRIM(RTRIM(i.CODE)),20),''),
	[NAME]          = left(LTRIM(RTRIM(i.NAME)),254), 
	[COST]          = CONVERT(NUMERIC(28,4),i.COST), 
	[COMMENTS]      = i.COMMENTS, 
	[STOCK]         = i.STOCK, 
	[DEP_LINK]      = dsk.LINK_NEW,
	[NOMENCLATURE]  = nsks.LINK_NEW,
	[TYPE_INV]      = CASE WHEN CONVERT(NUMERIC(28,4),i.COST) > 3000 THEN 1 ELSE 0 END,
	[ATTACH]        = 0,
	[LINK_OLD]      = i.LINK
FROM 
	{Variable_SmetaDb}.dbo.INVENTORY i
	INNER JOIN [{Variable_TempDb}].dbo.[__NOMENCLATURE_SMETA_KS] nsks ON nsks.LINK_OLD = i.NOMENCLATURE
	LEFT JOIN [{Variable_TempDb}].dbo.__DEPARTMENTS_SMETA_KS dsk ON dsk.LINK_OLD = i.DEP_LINK


SET @iROWCOUNT = @@ROWCOUNT

    INSERT INTO [{Variable_TempDb}].dbo.[__Journal]
    VALUES (' "  (-)"', ' : ' + convert(nvarchar(100),@iROWCOUNT), '', 0)
    
ALTER TABLE [{Variable_WorkDb}].[dbo].[INVENTORY] DROP COLUMN [LINK_OLD]
GO

INSERT INTO [{Variable_WorkDb}].dbo.[ASSETS] ([LINK_UP],
     [WEAR_OS],
     [OKOF],
     [DATE_FILLING],
     [EMP_FILLING],
     [CARD_NO],
     [GRP_CALC],
     [PASSPORT],
     [PLANT_NUM],
     [OTHER_NUM],
     [WEAR_FLAG],
     [DATE_PROD],
     [MANUFACT],
     [FIXING],
     [NO_TAX],
     [DEPRE_DATE_CALC],
     [PER_USED],
     [DATE_BEGIN],
     [DOC_NUM],
     [DEPRE_SUM],
     [DEPRE_GROUP],
     [PLACE],
     [DATE_COME], --   
     [LAST_PER_USED]
      )
SELECT
    [LINK_UP]       = isks.LINK_NEW,
    [WEAR_OS]       = NULL, -- 
    [OKOF]          = (SELECT TOP 1 LINK FROM [{Variable_WorkDb}].dbo.OKOF o WHERE o.CODE = REPLACE(REPLACE(ago.CODE {WORK_COLLATE},' ',''),'_','')),
    [DATE_FILLING]  = a.DATE_FILLING,
    [EMP_FILLING]   = (SELECT TOP 1 LINK_NEW FROM [{Variable_TempDb}].dbo.[__EMPL_SMETA_KS] WHERE LINK_OLD = a.EMP_FILLING),
    [CARD_NO]       = isnull(RIGHT(a.CARD_NO,20),''),
    [GRP_CALC]      = a.GRP_CALC,
    [PASSPORT]      = RIGHT(a.PASSPORT,50),
    [PLANT_NUM]     = RIGHT(a.PLANT_NUM,40),-- 
    [OTHER_NUM]     = a.OTHER_NUM,
    [WEAR_FLAG]     = a.WEAR_FLAG,
    [DATE_PROD]     = a.DATE_PROD,
    [MANUFACT]      = left(a.MANUFACT,80),
    [FIXING]        = left(a.FIXING,80),
    [NO_TAX]        = a.NO_TAX,
    --       (    + 1 , .. 01.01.)
    [DEPRE_DATE_CALC]= (CASE WHEN a.DEPRE_DATE_CALC IS NOT NULL THEN DATEADD(YEAR, DATEDIFF(YEAR, 0, GETDATE()), 0) ELSE NULL END),
    [PER_USED]      = (CASE WHEN a.DEPRE_DATE_CALC IS NULL THEN a.PER_USED ELSE a.PER_USED + ISNULL(DATEDIFF(MONTH, A.DATE_BEGIN, a.DEPRE_DATE_CALC), 0) END),
    [DATE_BEGIN]    = a.DATE_BEGIN,
    [DOC_NUM]       = RIGHT(a.DOC_NUM,8),
    [DEPRE_SUM]     = a.DEPRE_SUM,
    [DEPRE_GROUP]   = dg2.LINK,
    PLACE           = psks.LINK_NEW,
     --    =    
    [DATE_COME]		= DATEADD(MONTH, DATEDIFF(MONTH, 0, a.DEPRE_DATE_CALC), 0) - 1,
    LAST_PER_USED	= CASE WHEN a.DEPRE_DATE_CALC IS NULL 
							OR a.PER_USED <= DATEDIFF(MONTH,a.DEPRE_DATE_CALC,DATEADD(YEAR, DATEDIFF(YEAR, 0, GETDATE()), 0))
						THEN 0 
						ELSE a.PER_USED - DATEDIFF(MONTH,a.DEPRE_DATE_CALC,DATEADD(YEAR, DATEDIFF(YEAR, 0, GETDATE()), 0)) 
					END
FROM 
	{Variable_SmetaDb}.dbo.ASSETS a
	INNER JOIN [{Variable_TempDb}].dbo.[__INVENTORY_SMETA_KS] isks ON isks.LINK_OLD = a.LINK_UP
	LEFT JOIN {Variable_SmetaDb}.dbo.ASSETS_GROUP_OKOF ago ON ago.LINK = a.OKOF
	LEFT JOIN {Variable_SmetaDb}.dbo.DEPRE_GROUP dg ON dg.LINK = a.DEPRE_GROUP
	LEFT JOIN [{Variable_WorkDb}].dbo.DEPRE_GROUP dg2 ON dg2.CODE = dg.CODE {WORK_COLLATE}
	LEFT JOIN [{Variable_TempDb}].dbo.[__PLACEMENTS_SMETA_KS] psks ON psks.LINK_OLD = a.PLACE

/*
   "      ",
  "   "
 "   " 
*/
UPDATE A SET
	--
	DATE_COME = DATE_BEGIN
FROM 
	[{Variable_WorkDb}].dbo.[ASSETS] A
	INNER JOIN [{Variable_TempDb}].dbo.[__INVENTORY_SMETA_KS] isks ON isks.LINK_NEW = a.LINK_UP
WHERE
	--      
	A.[DEPRE_DATE_CALC] IS NULL
	AND
	--
	A.DATE_BEGIN IS NOT NULL

------------------------------------------
INSERT INTO [{Variable_WorkDb}].dbo.PRECIOUS
	(LINK_UP, BASIC_OBJ, PRECIOUS, UM, WEIGTH)
SELECT
	LINK_UP     = isks.LINK_NEW,
	BASIC_OBJ   = pc.BASIC_OBJ,
	PRECIOUS    = nsks.LINK_NEW,
	UM          = msks.LINK_NEW,
	WEIGTH      = CONVERT(NUMERIC(20,6),pc.WEIGTH)
FROM 
	{Variable_SmetaDb}.dbo.PRECIOUS_CONTENT pc
	INNER JOIN [{Variable_TempDb}].dbo.[__INVENTORY_SMETA_KS] isks ON isks.LINK_OLD = pc.LINK_UP
	LEFT JOIN [{Variable_TempDb}].dbo.[__NOMENCLATURE_SMETA_KS] nsks ON nsks.LINK_OLD = pc.PRECIOUS
	LEFT JOIN [{Variable_TempDb}].dbo.[__MEASURE_SMETA_KS] msks ON msks.LINK_OLD = pc.UM
			
		

---- !!!       
EXEC [{Variable_WorkDb}].dbo.GENERATE_GRP_ACTIVE_TREE_PATH
GO

INSERT INTO [{Variable_WorkDb}].dbo.ASSETS (LINK_UP,CARD_NO) 
select LINK,'' FROM [{Variable_WorkDb}].dbo.INVENTORY I 
WHERE NOT EXISTS (select 1 FROM [{Variable_WorkDb}].dbo.ASSETS WHERE LINK_UP = I.LINK )
GO


COMMIT TRAN

