
set xact_abort on
BEGIN TRAN
-- 
--   
USE {Variable_TempDb}
GO
IF not exists(select * from sysobjects where id = object_id('[dbo].[__DICTIONARY_TMC_SMETA_KS]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[__DICTIONARY_TMC_SMETA_KS] (
	[LINK_NEW] int ,
	[LINK_OLD] INT )
ELSE 
	DELETE FROM [dbo].[__DICTIONARY_TMC_SMETA_KS]

GO

IF Exists(select 1 from {Variable_WorkDb}.sys.columns where Name = N'LINK_OLD' and Object_ID = Object_ID(N'[{Variable_WorkDb}].[dbo].NOMENCLATURE'))
	BEGIN
	   ALTER TABLE [{Variable_WorkDb}].[dbo].NOMENCLATURE DROP COLUMN [LINK_OLD]
	END
GO
 ALTER TABLE [{Variable_WorkDb}].[dbo].NOMENCLATURE ADD [LINK_OLD] INT NULL
GO

--    ,  
declare	@obj1 INT, @iERROR INT
set	@obj1 = [{Variable_WorkDb}].dbo.obj_id('NOMENCLATURE_TMC')

DECLARE @iDEFAULT_LINK INT, @iLINK INT
SELECT @iDEFAULT_LINK = [{Variable_WorkDb}].dbo.getOwnDepLink()
SELECT TOP 1 @iLINK = LINK FROM [{Variable_WorkDb}].dbo.GROUP_ACTIVE ga WHERE ga.CODE_GRP = '80000' AND ga.[OBJECT] = @obj1 AND ga.LINK_DEP = @iLINK

IF @iLINK IS NULL
BEGIN
	
	IF NOT EXISTS (SELECT * FROM [{Variable_WorkDb}].dbo.GROUP_ACTIVE WHERE LINK_SELF IS NULL AND CODE_GRP = '80000')
		INSERT INTO [{Variable_WorkDb}].dbo.GROUP_ACTIVE 
			(CODE_GRP, [NAME], ACCOUNT_B, [SYSTEM], [TYPE], ACCOUNT_AM, ISUSED,	LINK_SELF, CODE_PRF, [OBJECT], LINK_DEP)
		SELECT '80000', '', NULL,0,2,NULL,1,NULL,NULL,@obj1,@iDEFAULT_LINK

	SELECT TOP 1 @iLINK = LINK FROM [{Variable_WorkDb}].dbo.GROUP_ACTIVE ga WHERE ga.CODE_GRP = '80000' AND ga.[OBJECT] = @obj1 AND ga.LINK_DEP = @iDEFAULT_LINK
	
END

IF OBJECT_ID('TEMPDB..#TAB1','U') IS NOT NULL
	DROP TABLE #TAB1

SELECT 
    CODE        = RIGHT(LTRIM(RTRIM(n.CODE {WORK_COLLATE})),20),
    [NAME]      = LTRIM(RTRIM(n.NAME {WORK_COLLATE})),
    GROUP_INV   = @iLINK,
    UM          = msks.LINK_NEW,
    SERIES      = '',
    IS_EXTRA    = 0,
    LINK_OKDP   = NULL,
    COEFF       = 1,
    PRICE_TYPE  = 0,
    ISUSED      = 1,
    LINK_DEP    = {LINK_DEP_MAIN},
    LINK_OLD    = n.LINK
INTO
	#TAB1    
FROM 
	{Variable_SmetaDb}.dbo.DICTIONARY_TMC n
	LEFT JOIN [{Variable_TempDb}].[dbo].[__MEASURE_SMETA_KS] msks ON msks.LINK_OLD = n.REF_CODE_D	

---  ,  
INSERT INTO [{Variable_TempDb}].dbo.[__DICTIONARY_TMC_SMETA_KS] ([LINK_NEW], [LINK_OLD])
SELECT DISTINCT
	[LINK_NEW] = N.LINK, 
	T.LINK_OLD
FROM 
	#TAB1 T
	INNER JOIN 
	(	
	SELECT LINK, [NAME],
		NUM = ROW_NUMBER() OVER (PARTITION BY [NAME] ORDER BY LINK)
	FROM 
		{Variable_WorkDb}.dbo.NOMENCLATURE
	WHERE 
		[LINK_DEP] = {LINK_DEP_MAIN}
		AND
		[GROUP_INV] = @iLINK
	) N ON N.[NAME] = T.[NAME]
WHERE
	N.NUM = 1


INSERT INTO [{Variable_WorkDb}].dbo.NOMENCLATURE
	(CODE, [NAME], GROUP_INV, UM, SERIES, IS_EXTRA, LINK_OKDP, COEFF, PRICE_TYPE, ISUSED, LINK_DEP, [LINK_OLD])
OUTPUT INSERTED.LINK,INSERTED.[LINK_OLD]
    INTO [{Variable_TempDb}].dbo.[__DICTIONARY_TMC_SMETA_KS]
SELECT 
    [CODE],
    [NAME],
    [GROUP_INV],
    [UM],
    [SERIES],
    [IS_EXTRA],
    [LINK_OKDP],
    [COEFF],
    [PRICE_TYPE],
    [ISUSED],
    [LINK_DEP],
    [LINK_OLD]
FROM 
	#TAB1 A
WHERE
	NOT EXISTS (SELECT * FROM [{Variable_TempDb}].dbo.[__DICTIONARY_TMC_SMETA_KS] T WHERE T.[LINK_OLD] = A.[LINK_OLD])		

DECLARE @iROWS_COPIED BIGINT
SET @iROWS_COPIED = @@ROWCOUNT

INSERT INTO [{Variable_TempDb}].dbo.[__Journal]
VALUES (' " (-)"', ' : ' + convert(nvarchar(100),@iROWS_COPIED), '', 0)

ALTER TABLE [{Variable_WorkDb}].[dbo].NOMENCLATURE DROP COLUMN [LINK_OLD]
GO

---- !!!       
EXEC [{Variable_WorkDb}].dbo.GENERATE_GRP_ACTIVE_TREE_PATH

COMMIT TRAN