
set xact_abort on
BEGIN TRAN

USE {Variable_TempDb}
GO

---    
IF not exists(select * from sysobjects where id = object_id('[dbo].[__DOC_TYPES_RecordRef]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[__DOC_TYPES_RecordRef] (
	[LINK_NEW] INT ,
	[LINK_OLD] INT )
ELSE 
	DELETE FROM [dbo].[__DOC_TYPES_RecordRef]
GO

IF COLUMNPROPERTY(object_id('[{Variable_WorkDb}].[dbo].[TYPE_OTHER_OPER]'), 'LINK_OLD', 'AllowsNull') IS NOT NULL
	BEGIN
	   ALTER TABLE [{Variable_WorkDb}].[dbo].TYPE_OTHER_OPER DROP COLUMN [LINK_OLD]
	END
GO
 ALTER TABLE [{Variable_WorkDb}].[dbo].TYPE_OTHER_OPER ADD [LINK_OLD] INT NULL
GO

--   
INSERT INTO [{Variable_TempDb}].dbo.[__DOC_TYPES_RecordRef] ([LINK_NEW],[LINK_OLD]) 
SELECT 
	[LINK_NEW] = P.LINK,
	D.[LINK]
FROM 
	{Variable_SmetaDb}.[dbo].DICTIONARY_DOC_TYPES d
	INNER JOIN (
		SELECT [LINK], [NAME], NUM = ROW_NUMBER() OVER (PARTITION BY NAME ORDER BY LINK)
		FROM [{Variable_WorkDb}].[dbo].TYPE_OTHER_OPER
		WHERE LINK_DEP = {LINK_DEP_MAIN}
	) P ON P.NUM = 1 AND P.[NAME] = LEFT(d.NAME {WORK_COLLATE},254)

--
INSERT INTO [{Variable_WorkDb}].[dbo].TYPE_OTHER_OPER (CODE,NAME,BKS_CODE,[SYSTEM],LINK_DEP,LINK_OLD)
    OUTPUT INSERTED.LINK, INSERTED.LINK_OLD INTO [{Variable_TempDb}].dbo.[__DOC_TYPES_RecordRef]
SELECT distinct
	CODE        = LEFT(LTRIM(RTRIM(CODE)),10), 
	[NAME]      = LEFT(LTRIM(RTRIM(NAME)),254),
	[BKS_CODE] = LEFT(LTRIM(RTRIM(CODE_BKS)),30),
	[SYSTEM] = 0,
	LINK_DEP    = {LINK_DEP_MAIN}, 
	[LINK_OLD]  = LINK
FROM 
	{Variable_SmetaDb}.[dbo].DICTIONARY_DOC_TYPES D
WHERE
	NOT EXISTS (SELECT * FROM [{Variable_TempDb}].[dbo].[__DOC_TYPES_RecordRef] T WHERE T.[LINK_OLD] = D.LINK)

--    
DECLARE @iROWCOUNT INT
SET @iROWCOUNT = @@ROWCOUNT
INSERT INTO [{Variable_TempDb}].dbo.[__Journal]
VALUES (' "  "', ' : ' + convert(nvarchar(100),@iROWCOUNT), '', 0)

---   
IF not exists(select * from sysobjects where id = object_id('[dbo].[__DOC_TYPES_]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[__DOC_TYPES_] (
	[LINK_NEW] INT ,
	[LINK_OLD] INT )
ELSE 
	DELETE FROM [dbo].[__DOC_TYPES_]
GO

--   
INSERT INTO [{Variable_TempDb}].dbo.[__DOC_TYPES_] ([LINK_NEW],[LINK_OLD]) 
SELECT DISTINCT
	[LINK_NEW] = P.LINK,
	SO.LINK
FROM 
	{Variable_SmetaDb}.dbo.G_PROV G
	INNER JOIN {Variable_SmetaDb}.dbo.S_OBJECTS SO ON SO.LINK = G.[OBJECT]
	INNER JOIN (
		SELECT [LINK], [NAME], NUM = ROW_NUMBER() OVER (PARTITION BY NAME ORDER BY LINK)
		FROM [{Variable_WorkDb}].[dbo].TYPE_OTHER_OPER
		WHERE LINK_DEP = {LINK_DEP_MAIN}
	) P ON P.NUM = 1 AND P.[NAME] = LEFT(SO.NAME {WORK_COLLATE},254)
WHERE
	G.[DATE] >= DATEADD(YEAR, DATEDIFF(YEAR, 0, GETDATE()), 0)
	AND
	NOT EXISTS (SELECT * FROM [{Variable_TempDb}].[dbo].[__DOC_TYPES_] T WHERE T.[LINK_OLD] = SO.LINK)	

INSERT INTO [{Variable_WorkDb}].[dbo].TYPE_OTHER_OPER (CODE,NAME,[SYSTEM],LINK_DEP,LINK_OLD)
    OUTPUT INSERTED.LINK, INSERTED.LINK_OLD INTO [{Variable_TempDb}].dbo.[__DOC_TYPES_]
SELECT DISTINCT 'KS_'+RIGHT(LTRIM(RTRIM(SO.CODE)),7), SO.NAME, [SYSTEM] = 0, LINK_DEP = {LINK_DEP_MAIN}, [LINK_OLD]  = SO.LINK 
FROM
	{Variable_SmetaDb}.dbo.G_PROV G
	INNER JOIN {Variable_SmetaDb}.dbo.S_OBJECTS SO ON SO.LINK = G.[OBJECT]
WHERE
	G.[DATE] >= DATEADD(YEAR, DATEDIFF(YEAR, 0, GETDATE()), 0)
	AND
	NOT EXISTS (SELECT * FROM [{Variable_TempDb}].[dbo].[__DOC_TYPES_] T WHERE T.[LINK_OLD] = SO.LINK)		

--    
DECLARE @iROWCOUNT INT
SET @iROWCOUNT = @@ROWCOUNT
INSERT INTO [{Variable_TempDb}].dbo.[__Journal]
VALUES (' "  "', '  : ' + convert(nvarchar(100),@iROWCOUNT), '', 0)
--
	

ALTER TABLE [{Variable_WorkDb}].[dbo].TYPE_OTHER_OPER DROP COLUMN [LINK_OLD]
GO

COMMIT TRAN
