set xact_abort on
BEGIN TRAN

---- PERSONS
GO
USE {Variable_TempDb}
GO
IF not exists(select * from sysobjects where id = object_id('[dbo].[__PERSON_SMETA_KS]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[__PERSON_SMETA_KS] (
	[LINK_NEW] int ,
	[LINK_OLD] int  )
ELSE 
	DELETE FROM [dbo].[__PERSON_SMETA_KS]
GO

IF Exists(select 1 from {Variable_WorkDb}.sys.columns where Name = N'LINK_OLD' and Object_ID = Object_ID(N'[{Variable_WorkDb}].[dbo].PERSON'))
	BEGIN
	   ALTER TABLE [{Variable_WorkDb}].[dbo].PERSON DROP COLUMN [LINK_OLD]
	END
GO
 ALTER TABLE [{Variable_WorkDb}].[dbo].PERSON ADD [LINK_OLD] INT NULL
GO

IF OBJECT_ID('TEMPDB..#PERS','U') IS NOT NULL
	DROP TABLE #PERS
GO

CREATE TABLE #PERS (LINK INT)

INSERT INTO #PERS (LINK)	
SELECT LINK
FROM
	{Variable_SmetaDb}.dbo.PERSON A
WHERE 
	-- 
	EXISTS (SELECT * FROM {Variable_SmetaDb}.dbo.EMPL E INNER JOIN [{Variable_TempDb}].dbo.[__DEPARTMENTS_SMETA_KS] dsks ON dsks.LINK_OLD = e.DEP_LINK WHERE e.PERS_LINK = A.LINK)
	OR -- 
	EXISTS (SELECT * FROM {Variable_SmetaDb}.dbo.DEPARTMENTS D INNER JOIN {Variable_SmetaDb}.dbo.G_PROV_AP GAP ON GAP.DEP = D.LINK WHERE D.PERS_LINK = A.LINK)
GO

--   1
INSERT INTO [dbo].[__PERSON_SMETA_KS] ([LINK_NEW],[LINK_OLD])
SELECT 
	[LINK_NEW] = P.LINK,
	[LINK_OLD] = T.LINK
FROM
	(	
	SELECT 
		INN             = isnull(A.INN {WORK_COLLATE},''), 
		A.LINK
	FROM 
		{Variable_SmetaDb}.dbo.PERSON A INNER JOIN #PERS P ON P.LINK = A.LINK
	) T
	INNER JOIN (
	SELECT 
		LINK, P.INN, 
		NUM = ROW_NUMBER() OVER (PARTITION BY P.INN ORDER BY LINK) 
	FROM 
		[{Variable_WorkDb}].dbo.PERSON P	
	) P 
	ON P.NUM = 1 AND P.INN = T.INN
WHERE
	LTRIM(RTRIM(ISNULL(P.INN,''))) <> ''
	AND
	LTRIM(RTRIM(ISNULL(T.INN {WORK_COLLATE},''))) <> ''
GO


--   2
INSERT INTO [dbo].[__PERSON_SMETA_KS] ([LINK_NEW],[LINK_OLD])
SELECT 
	[LINK_NEW] = P.LINK,
	[LINK_OLD] = T.LINK
FROM
	(	
	SELECT 
		DOC_NUM = REPLACE(isnull(LTRIM(RTRIM(A.DOC_NUM {WORK_COLLATE})),''),'-',''),
		A.LINK
	FROM 
		{Variable_SmetaDb}.dbo.PERSON A INNER JOIN #PERS P ON P.LINK = A.LINK
	) T
	INNER JOIN (
	SELECT 
		LINK, P.DOC_NUM, 
		NUM = ROW_NUMBER() OVER (PARTITION BY P.DOC_NUM ORDER BY LINK) 
	FROM 
		[{Variable_WorkDb}].dbo.PERSON P	
	) P 
	ON P.NUM = 1 AND LTRIM(RTRIM(ISNULL(P.DOC_NUM,''))) = T.DOC_NUM
WHERE
	LTRIM(RTRIM(ISNULL(P.DOC_NUM,''))) <> ''
	AND
	LTRIM(RTRIM(ISNULL(T.DOC_NUM {WORK_COLLATE},''))) <> ''	
	AND
	NOT EXISTS (SELECT * FROM [dbo].[__PERSON_SMETA_KS] R WHERE R.[LINK_OLD] = T.LINK)	
GO


--   3
INSERT INTO [dbo].[__PERSON_SMETA_KS] ([LINK_NEW],[LINK_OLD])
SELECT 
	[LINK_NEW] = P.LINK,
	[LINK_OLD] = T.LINK
FROM
	(	
	SELECT 
		FM = ISNULL(LTRIM(RTRIM(A.FM {WORK_COLLATE})),''),
		IM = ISNULL(LTRIM(RTRIM(A.IM {WORK_COLLATE})),''),
		OT = ISNULL(LTRIM(RTRIM(A.OT {WORK_COLLATE})),''),
		A.LINK
	FROM 
		{Variable_SmetaDb}.dbo.PERSON A INNER JOIN #PERS P ON P.LINK = A.LINK
	WHERE		
		LTRIM(RTRIM(ISNULL(A.INN {WORK_COLLATE},''))) = ''
		AND
		LTRIM(RTRIM(ISNULL(A.DOC_NUM {WORK_COLLATE},''))) = ''
	) T
	INNER JOIN (
	SELECT 
		LINK, P.FM, P.IM, P.OT, 
		NUM = ROW_NUMBER() OVER (PARTITION BY P.FM, P.IM, P.OT ORDER BY P.FM, P.IM, P.OT DESC) 
	FROM 
		[{Variable_WorkDb}].dbo.PERSON P		
	WHERE	
		LTRIM(RTRIM(ISNULL(P.INN,''))) = ''
		AND
		LTRIM(RTRIM(ISNULL(P.DOC_NUM,''))) = ''		
	) P 
	ON P.NUM = 1 
		AND ISNULL(LTRIM(RTRIM(P.FM)),'') = ISNULL(LTRIM(RTRIM(T.FM)),'') 
		AND ISNULL(LTRIM(RTRIM(P.IM)),'') = ISNULL(LTRIM(RTRIM(T.IM)),'') 
		AND ISNULL(LTRIM(RTRIM(P.OT)),'') = ISNULL(LTRIM(RTRIM(T.OT)),'')
WHERE
	LTRIM(RTRIM(ISNULL(T.FM,''))) <> ''
	AND
	LTRIM(RTRIM(ISNULL(P.FM,''))) <> ''
	AND
	LTRIM(RTRIM(ISNULL(P.IM,''))) <> ''
	AND
	LTRIM(RTRIM(ISNULL(T.IM,''))) <> ''
	AND	
	NOT EXISTS (SELECT * FROM [dbo].[__PERSON_SMETA_KS] R WHERE R.[LINK_OLD] = T.LINK)	
GO

INSERT INTO [{Variable_WorkDb}].dbo.PERSON
(FM, IM, OT, DOC_LINK, DOC_NUM, DOC_WHOM, DOC_DATE, INN, KLADR_LINK, HOUSE, CORP, FLAT, ADR_OFIC_LINK, HOUSE_OFIC,LINK_DEP, [LINK_OLD], DRIVER_DOC_NUMBER,
DRIVER_CLASS)
    OUTPUT INSERTED.LINK, INSERTED.[LINK_OLD]
    INTO [{Variable_TempDb}].[dbo].[__PERSON_SMETA_KS]
SELECT DISTINCT
	FM              = LTRIM(RTRIM(p.FM)), 
	IM              = LTRIM(RTRIM(p.IM)),
	OT              = LTRIM(RTRIM(p.OT)), 
	DOC_LINK        = fd.LINK,
	DOC_NUM         = REPLACE(isnull(LTRIM(RTRIM(p.DOC_NUM)),''),'-',''),
	DOC_WHOM        = isnull(LTRIM(RTRIM(p.DOC_WHOM)),''),
	DOC_DATE        = p.DOC_DATE,
	INN             = p.INN,
	KLADR_LINK      = ISNULL((SELECT TOP 1 LINK FROM [{Variable_WorkDb}].dbo.KLADR WHERE CODE = LTRIM(KL2.CODE)),0),
	HOUSE           = LEFT(LTRIM(RTRIM(p.HOUSE_REAL)),8),
	CORP            = LTRIM(RTRIM(p.CORP_REAL)),
	FLAT            = LEFT(LTRIM(RTRIM(p.FLAT_REAL)),4),
	ADR_OFIC_LINK   = ISNULL((SELECT TOP 1 LINK FROM [{Variable_WorkDb}].dbo.KLADR WHERE CODE = LTRIM(KL1.CODE)),0),
	HOUSE_OFIC      = p.HOUSE_OFIC,
	LINK_DEP        = {LINK_DEP_MAIN},
	LINK_OLD        = p.LINK,
	DRIVER_DOC_NUMBER = LEFT(p.DRIVER_DOC_NUM,10),
	DRIVER_CLASS    = p.DRIVER_KLASS
FROM 
	{Variable_SmetaDb}.dbo.PERSON p
	INNER JOIN #PERS A ON P.LINK = A.LINK
	LEFT JOIN {Variable_SmetaDb}.dbo.KLADR KL1 ON KL1.LINK = P.ADR_OFIC_LINK
	LEFT JOIN {Variable_SmetaDb}.dbo.KLADR KL2 ON KL2.LINK = P.ADR_REAL_LINK	
	LEFT JOIN {Variable_SmetaDb}.dbo.KLADR KL ON KL.LINK = P.ADR_OFIC_LINK
	LEFT JOIN [{Variable_WorkDb}].dbo.FACE_DOCUMENT fd ON LTRIM(RTRIM( fd.CODE )) = [{Variable_WorkDb}].dbo.getOwnDepLink()
WHERE	
	NOT EXISTS (SELECT * FROM [dbo].[__PERSON_SMETA_KS] R WHERE R.[LINK_OLD] = p.LINK)	
 
  
--    
DECLARE @iROWCOUNT INT
SET @iROWCOUNT = @@ROWCOUNT
INSERT INTO [{Variable_TempDb}].dbo.[__Journal]
VALUES (' "  (-)"', ' : ' + convert(nvarchar(100),@iROWCOUNT), '', 0)
--

ALTER TABLE [{Variable_WorkDb}].[dbo].PERSON DROP COLUMN [LINK_OLD]

GO
-----

---   "" ---

USE {Variable_TempDb}
GO
IF not exists(select * from sysobjects where id = object_id('[dbo].[__EMPL_SMETA_KS]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[__EMPL_SMETA_KS] (
	[LINK_NEW] int ,
	[LINK_OLD] INT )
ELSE 
	DELETE FROM [dbo].[__EMPL_SMETA_KS]
	
GO

IF Exists(select 1 from {Variable_WorkDb}.sys.columns where Name = N'LINK_OLD' and Object_ID = Object_ID(N'[{Variable_WorkDb}].[dbo].[EMPL]'))
	BEGIN
	   ALTER TABLE [{Variable_WorkDb}].[dbo].[EMPL] DROP COLUMN [LINK_OLD]
	END
GO
 ALTER TABLE [{Variable_WorkDb}].[dbo].[EMPL] ADD [LINK_OLD] INT NULL
GO


INSERT INTO [{Variable_WorkDb}].[dbo].[EMPL]
           ([PERS_LINK]
           ,[TAB]
           ,[DEP_LINK]
           ,[PHONE_S]
           ,[PHONE_M]
           ,[EMAIL]
           ,[LINK_OLD])
           
OUTPUT INSERTED.LINK, INSERTED.[LINK_OLD]
INTO [{Variable_TempDb}].dbo.[__EMPL_SMETA_KS]
    
SELECT DISTINCT
	sks.LINK_NEW,
	TAB         = e.TAB,
	DEP_LINK    = dsks.LINK_NEW,
	PHONE_S     = '',
	PHONE_M     = '',
	EMAIL       = '',
	[LINK_OLD]  = e.LINK
FROM 
	{Variable_SmetaDb}.dbo.EMPL e
	INNER JOIN [{Variable_TempDb}].dbo.[__PERSON_SMETA_KS] sks ON sks.LINK_OLD = e.PERS_LINK
	INNER JOIN [{Variable_TempDb}].dbo.[__DEPARTMENTS_SMETA_KS] dsks ON dsks.LINK_OLD = e.DEP_LINK 

ALTER TABLE [{Variable_WorkDb}].[dbo].[EMPL] DROP COLUMN [LINK_OLD]
GO

DECLARE @dDATE_TODAY DATETIME
SET @dDATE_TODAY = GETDATE()

INSERT INTO [{Variable_WorkDb}].[dbo].[EMPL_POST]
           ([LINK_UP]
           ,[POST_LINK]
           ,[SUBDIV_LINK]
           ,[DATE_BEG]
           ,[DATE_END])
SELECT
	[LINK_UP]       = ES.LINK_NEW,
	[POST_LINK]     = MAX(PD.LINK_NEW),
	[SUBDIV_LINK]   = MAX(s.LINK_UP),
	[DATE_BEG]      = ISNULL(pf.DATE_BEGIN,DATEADD(yy, DATEDIFF(yy,0,getdate()), 0)),
	[DATE_END]      = pf.DATE_SACK
FROM 
	{Variable_SmetaDb}.dbo.ku_empl_placing_fn(@dDATE_TODAY) pf
	INNER JOIN [{Variable_TempDb}].[dbo].__EMPL_SMETA_KS ES ON ES.LINK_OLD = pf.LINK
	INNER JOIN [{Variable_TempDb}].[dbo].[__SUBDIV_SMETA_KS] SP ON SP.LINK_OLD = pf.SUBDIV_LINK
	INNER JOIN [{Variable_WorkDb}].dbo.SUBDIV s ON S.LINK = SP.LINK_NEW
	INNER JOIN [{Variable_TempDb}].[dbo].[__EMPL_POST_SMETA_KS] PD ON PD.LINK_OLD = pf.POST_LINK
GROUP BY
	ES.LINK_NEW,
	pf.DATE_BEGIN,
	pf.DATE_SACK	

COMMIT TRAN
