set xact_abort on
BEGIN TRAN

USE {Variable_TempDb}
GO
IF not exists(select * from sysobjects where id = object_id('[dbo].[__EMPL_GROUPS_SMETA_KS]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[__EMPL_GROUPS_SMETA_KS] (
	[LINK_NEW] int ,
	[LINK_OLD] INT )
ELSE 
	DELETE FROM [dbo].[__EMPL_GROUPS_SMETA_KS]

GO

IF Exists(select 1 from {Variable_WorkDb}.sys.columns where Name = N'LINK_OLD' and Object_ID = Object_ID(N'[{Variable_WorkDb}].[dbo].EMPL_GROUPS'))
	BEGIN
	   ALTER TABLE [{Variable_WorkDb}].[dbo].EMPL_GROUPS DROP COLUMN [LINK_OLD]
	END
GO
 ALTER TABLE [{Variable_WorkDb}].[dbo].EMPL_GROUPS ADD [LINK_OLD] INT NULL
GO

--   
INSERT INTO [{Variable_TempDb}].dbo.[__EMPL_GROUPS_SMETA_KS] ([LINK_NEW],[LINK_OLD]) 
SELECT 
	[LINK_NEW] = P.LINK,
	[LINK_OLD] = D.LINK
FROM 
	(	SELECT LINK, NAME {WORK_COLLATE} AS NAME, NUM = ROW_NUMBER() OVER (PARTITION BY [NAME] ORDER BY LINK)
		FROM {Variable_SmetaDb}.dbo.GROUPS_EMPL
	) d
	INNER JOIN (
		SELECT LINK, [NAME], NUM = ROW_NUMBER() OVER (PARTITION BY [NAME] ORDER BY LINK)
		FROM [{Variable_WorkDb}].[dbo].EMPL_GROUPS P 
		WHERE LINK_DEP = {LINK_DEP_MAIN}
	) P ON P.NUM = 1 AND P.[NAME] = LEFT(d.[NAME],254)
WHERE
	D.NUM = 1	
GO

--    
INSERT INTO [{Variable_WorkDb}].[dbo].EMPL_GROUPS
(SNAME, [NAME], SYS, LINK_DEP, [LINK_OLD])
    OUTPUT INSERTED.LINK, INSERTED.LINK_OLD
    INTO [{Variable_TempDb}].dbo.[__EMPL_GROUPS_SMETA_KS]
SELECT 
	SNAME   = ge.CODE,
	[NAME]  = LEFT(ge.NAME,60),
	SYS     = 0,
	LINK_DEP = {LINK_DEP_MAIN},
	LINK_OLD = ge.LINK
FROM 
	{Variable_SmetaDb}.dbo.GROUPS_EMPL ge
WHERE
	NOT EXISTS ( SELECT * FROM [{Variable_TempDb}].dbo.[__EMPL_GROUPS_SMETA_KS] T WHERE T.[LINK_OLD] = ge.[LINK] )	

--    
DECLARE @iROWCOUNT INT
SET @iROWCOUNT = @@ROWCOUNT
INSERT INTO [{Variable_TempDb}].dbo.[__Journal]
VALUES (' "  (-)"', ' : ' + convert(nvarchar(100),@iROWCOUNT), '', 0)
--
ALTER TABLE [{Variable_WorkDb}].[dbo].EMPL_GROUPS DROP COLUMN [LINK_OLD]
GO

------    
INSERT INTO [{Variable_WorkDb}].dbo.EMPL_GROUPS_REF (EMPL_LINK, GROUP_LINK)
SELECT
	esks.LINK_NEW, egsks.LINK_NEW
FROM 
	{Variable_SmetaDb}.dbo.GROUPS_EMPL ge
	INNER JOIN {Variable_SmetaDb}.dbo.GROUPS_EMPL_REF ger ON ger.LINK_GROUP = ge.LINK
	INNER JOIN [{Variable_TempDb}].dbo.[__EMPL_SMETA_KS] esks ON esks.LINK_OLD = ger.LINK_EMPL
	LEFT JOIN [{Variable_TempDb}].dbo.[__EMPL_GROUPS_SMETA_KS] egsks ON egsks.LINK_OLD = ge.LINK

COMMIT TRAN
