-- 05. -  --
SET XACT_ABORT ON
BEGIN TRAN

/*
{Variable_TempDb} =	bs_ks_rp_tmp
{Variable_WorkDb} =	bs_ks_rp
{Variable_SmetaDb} = b_ks_rp
{LINK_DEP_MAIN}	= 296172
*/
-- select * from {Variable_WorkDb}..departments where link = 296172

USE {Variable_TempDb}
GO

--   --
IF not exists(select * from sysobjects where id = object_id('[dbo].[__PF_BENEFIT_FROM_SMETA_KS]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
	CREATE TABLE [dbo].[__PF_BENEFIT_FROM_SMETA_KS]
		(
		[LINK] INT,
		[DEP_CB] INT,
		VAL_SMETA	NUMERIC (10,2)
		)
GO

DELETE T1
FROM [dbo].[__PF_BENEFIT_FROM_SMETA_KS] T1
WHERE NOT EXISTS
	(
	SELECT 1
	FROM {Variable_WorkDb}.[dbo].PF_BENEFIT TTT
	WHERE TTT.LINK = T1.LINK
	)
GO

--   --
IF not exists(select * from sysobjects where id = object_id('[dbo].[__PF_COMPENSATIONS_FROM_SMETA_KS]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
	CREATE TABLE [dbo].[__PF_COMPENSATIONS_FROM_SMETA_KS]
		(
		[LINK] INT,
		[DEP_CB] INT,
		VAL_SMETA	NUMERIC (10,2)
		)
GO

DELETE T1
FROM [dbo].[__PF_COMPENSATIONS_FROM_SMETA_KS] T1
WHERE NOT EXISTS
	(
	SELECT 1
	FROM {Variable_WorkDb}.[dbo].PF_COMPENSATIONS TTT
	WHERE TTT.LINK = T1.LINK
	)
GO

USE {Variable_WorkDb}
GO

IF Exists(select 1 from sys.columns where Name = N'VAL_SMETA' and Object_ID = Object_ID(N'[dbo].PF_BENEFIT'))
   ALTER TABLE [dbo].PF_BENEFIT DROP COLUMN [VAL_SMETA]
GO

ALTER TABLE [dbo].PF_BENEFIT ADD [VAL_SMETA] NUMERIC (10,2) NULL 
GO

IF Exists(select 1 from sys.columns where Name = N'VAL_SMETA' and Object_ID = Object_ID(N'[dbo].PF_COMPENSATIONS'))
   ALTER TABLE [dbo].PF_COMPENSATIONS DROP COLUMN [VAL_SMETA]
GO

ALTER TABLE [dbo].PF_COMPENSATIONS ADD [VAL_SMETA] NUMERIC (10,2) NULL 
GO

-- 1.   -  --
-- dbo.PF_SERVICE_REC --
UPDATE T1
SET
	[COMMENT]		= '  ' + CONVERT(VARCHAR(10), OLD_DOC.DATE_BEGIN, 104)
FROM dbo.PF_SERVICE_REC T1
INNER JOIN dbo.DEPARTMENT_ACCOUNTS DEP_ACC ON (DEP_ACC.LINK = T1.DEP_ACC)
INNER JOIN {Variable_TempDb}.[dbo].[__DEP_CHILD_SMETA_KS] CH_DEP ON (CH_DEP.LINK_NEW = DEP_ACC.LINK_UP)
INNER JOIN {Variable_SmetaDb}.dbo.RP_DOGOVORY OLD_DOC ON (OLD_DOC.DET_LINK = CH_DEP.LINK_OLD)
WHERE
	ISNULL ([COMMENT], '') = ''
	AND ISNULL (OLD_DOC.DATE_BEGIN, '19000101') > '19000101' 

-- 2.   -  --
-- dbo.PF_SERVICE_REC_GROUP --
INSERT INTO dbo.PF_SERVICE_REC_GROUP 
	(
	LINK_UP,
	DATE_BEG,
	DATE_END,
	[GROUP],
	RATIO,
	AP1
	)
SELECT
	LINK_UP	=	T1.LINK,
	DATE_BEG	=	ISNULL (DOC_OLD.DATE_BEGIN, GRP_NEW.DATE_BEG),
	DATE_END	=	DOC_OLD.DATE_END,
	[GROUP]		=	GRP_NEW.LINK,
	RATIO	=	1,
	AP1		=	DOC_NEW.LINK
FROM dbo.PF_SERVICE_REC T1
INNER JOIN dbo.DEPARTMENT_ACCOUNTS DEP_ACC ON (DEP_ACC.LINK = T1.DEP_ACC)
INNER JOIN {Variable_TempDb}.[dbo].[__DEP_CHILD_SMETA_KS] CH_DEP ON (CH_DEP.LINK_NEW = DEP_ACC.LINK_UP)

LEFT JOIN {Variable_SmetaDb}.dbo.RP_DOGOVORY DOC_OLD ON (DOC_OLD.DET_LINK = CH_DEP.LINK_OLD)
LEFT JOIN {Variable_SmetaDb}.dbo.RP_DETY CH_OLD ON (CH_OLD.LINK = CH_DEP.LINK_OLD)

LEFT JOIN {Variable_TempDb}.[dbo].[__G_PROV_RP_DOG_SMETA_KS] DOC ON (DOC.LINK_OLD = DOC_OLD.LINK)
LEFT JOIN dbo.G_PROV DOC_NEW ON (DOC_NEW.LINK = DOC.LINK_NEW)

LEFT JOIN {Variable_TempDb}.[dbo].[__PF_GROUP_SERVICE_REC_SMETA_KS] GRP ON (GRP.LINK_OLD = CH_OLD.GROUP_LINK)
LEFT JOIN dbo.PF_GROUP_SERVICE_REC GRP_NEW ON (GRP_NEW.LINK = GRP.LINK_NEW)

WHERE NOT EXISTS
	(
	SELECT 1
	FROM dbo.PF_SERVICE_REC_GROUP TTT
	WHERE TTT.LINK_UP = T1.LINK
		AND TTT.[GROUP]	=	GRP.LINK_NEW
	)

-- 3.   -  --
--  --
DECLARE @T_BENEFIT_BY_CHILD TABLE 
	(
	LINK_CB	INT,
	VAL_SMETA	NUMERIC (10,2),
	DATE_BEGIN	DATETIME,
	DEP_CHILD	INT
	)

INSERT INTO @T_BENEFIT_BY_CHILD
	(
	LINK_CB,
	VAL_SMETA,
	DATE_BEGIN,
	DEP_CHILD
	)
SELECT
	CB.LINK_CB,
	CASE
		WHEN DOC_OLD.SUM_PERCENT_PLATI < 100 THEN DOC_OLD.SUM_PERCENT_PLATI
		ELSE 100
	END,	
	CASE
		WHEN ISDATE (DOC_OLD.DATE_BEGIN) = 1 THEN DOC_OLD.DATE_BEGIN
		ELSE '19000101'
	END,
	CH_REF.LINK_NEW
FROM {Variable_SmetaDb}.dbo.RP_DOGOVORY DOC_OLD
INNER JOIN {Variable_TempDb}.[dbo].[__G_PROV_RP_DOG_SMETA_KS] DOC ON (DOC.LINK_OLD = DOC_OLD.LINK)
INNER JOIN dbo.G_PROV DOC_NEW ON (DOC_NEW.LINK = DOC.LINK_NEW)
INNER JOIN dbo.V_DEP CB ON (CB.LINK = DOC_NEW.DEP)

INNER JOIN {Variable_TempDb}.[dbo].[__DEP_CHILD_SMETA_KS] CH_REF ON (CH_REF.LINK_OLD = DOC_OLD.DET_LINK)
WHERE ISNULL (DOC_OLD.SUM_PERCENT_PLATI, 0) > 0

--SELECT '@T_BENEFIT_BY_CHILD', * FROM @T_BENEFIT_BY_CHILD

--   --
DECLARE @T_BENEFIT_SMETA TABLE 
	(
	LINK_CB	INT,
	VAL_SMETA	NUMERIC (10,2),
	DATE_BEGIN	DATETIME
	)

INSERT INTO @T_BENEFIT_SMETA  
	(
	LINK_CB,
	VAL_SMETA,
	DATE_BEGIN
	)
SELECT
	LINK_CB,
	VAL_SMETA,
	MIN (DATE_BEGIN)
FROM @T_BENEFIT_BY_CHILD
GROUP BY
	LINK_CB,
	VAL_SMETA

-- dbo.PF_BENEFIT --
INSERT INTO dbo.PF_BENEFIT
	(
	CODE,
	NAME,
	ROUNDING,
	ROUNDING_WAY,
	LINK_DEP,
	VAL_SMETA
	)
OUTPUT INSERTED.LINK, INSERTED.LINK_DEP, INSERTED.VAL_SMETA
	INTO {Variable_TempDb}.dbo.[__PF_BENEFIT_FROM_SMETA_KS]
SELECT
	CODE	=	REPLACE (CAST (T1.VAL_SMETA AS VARCHAR (10)), '.', '_'),
	NAME	=	'  ' + CAST (T1.VAL_SMETA AS VARCHAR (10)),
	ROUNDING	=	1,
	ROUNDING_WAY	=	1,
	LINK_DEP	=	T1.LINK_CB,
	T1.VAL_SMETA
FROM @T_BENEFIT_SMETA T1
WHERE NOT EXISTS
	(
	SELECT 1
	FROM {Variable_TempDb}.[dbo].[__PF_BENEFIT_FROM_SMETA_KS] TTT
	WHERE
		TTT.[DEP_CB] = T1.LINK_CB
		AND TTT.VAL_SMETA = T1.VAL_SMETA
	)

-- dbo.PF_BENEFIT_TABLE --
INSERT INTO dbo.PF_BENEFIT_TABLE
	(
	LINK_UP,
	[DATE],
	[PERCENT],
	SUMMA
	)
SELECT
	LINK_UP	=	T1.LINK,
	[DATE]	=	ISNULL (T3.DATE_BEGIN, '19900101'),
	[PERCENT]	=	T2.VAL_SMETA,
	SUMMA	=	0
FROM dbo.PF_BENEFIT T1
INNER JOIN {Variable_TempDb}.[dbo].[__PF_BENEFIT_FROM_SMETA_KS] T2 ON (T2.LINK = T1.LINK)
INNER JOIN @T_BENEFIT_SMETA T3 ON 
	(
	T3.VAL_SMETA = T2.VAL_SMETA
	AND T3.LINK_CB = T2.DEP_CB
	)
WHERE NOT EXISTS
	(
	SELECT 1
	FROM dbo.PF_BENEFIT_TABLE TTT
	WHERE TTT.LINK_UP = T1.LINK
	)

-- dbo.PF_SERVICE_REC_BENEFIT --
INSERT INTO dbo.PF_SERVICE_REC_BENEFIT 
	(
	LINK_UP,
	DATE_BEG,
	DATE_END,
	BENEFIT
	)
SELECT
	LINK_UP = T1.LINK,
	DATE_BEG	=	T2.DATE_BEGIN,
	DATE_END	=	NULL,
	BENEFIT		=	BEN.LINK
FROM dbo.PF_SERVICE_REC T1
INNER JOIN dbo.DEPARTMENT_ACCOUNTS DEP_ACC ON (DEP_ACC.LINK = T1.DEP_ACC)
INNER JOIN @T_BENEFIT_BY_CHILD T2 ON (T2.DEP_CHILD = DEP_ACC.LINK_UP)

INNER JOIN {Variable_TempDb}.dbo.[__PF_BENEFIT_FROM_SMETA_KS] BEN_REF ON
	(
	BEN_REF.VAL_SMETA = T2.VAL_SMETA
	AND BEN_REF.DEP_CB = T2.LINK_CB
	)
INNER JOIN dbo.PF_BENEFIT BEN ON (BEN.LINK = BEN_REF.LINK)
WHERE NOT EXISTS
	(
	SELECT 1
	FROM dbo.PF_SERVICE_REC_BENEFIT TTT
	WHERE TTT.LINK_UP = T1.LINK
		AND TTT.BENEFIT = BEN.LINK
	)

-- 4.   -    --
--  --
DECLARE @T_COMPENS_BY_CHILD TABLE 
	(
	LINK_CB	INT,
	VAL_SMETA	NUMERIC (10,2),
	DATE_BEGIN	DATETIME,
	DEP_CHILD	INT
	)

INSERT INTO @T_COMPENS_BY_CHILD
	(
	LINK_CB,
	VAL_SMETA,
	DATE_BEGIN,
	DEP_CHILD
	)
SELECT
	CB.LINK_CB,
	DOC_OLD.KOMPENS,
	DOC_OLD.DATE_BEGIN,
	CH_REF.LINK_NEW
FROM {Variable_SmetaDb}.dbo.RP_DOGOVORY DOC_OLD
INNER JOIN {Variable_TempDb}.[dbo].[__G_PROV_RP_DOG_SMETA_KS] DOC ON (DOC.LINK_OLD = DOC_OLD.LINK)
INNER JOIN dbo.G_PROV DOC_NEW ON (DOC_NEW.LINK = DOC.LINK_NEW)
INNER JOIN dbo.V_DEP CB ON (CB.LINK = DOC_NEW.DEP)

INNER JOIN {Variable_TempDb}.[dbo].[__DEP_CHILD_SMETA_KS] CH_REF ON (CH_REF.LINK_OLD = DOC_OLD.DET_LINK)
WHERE ISNULL (DOC_OLD.KOMPENS, 0) > 0

--SELECT '@T_COMPENS_BY_CHILD', * FROM @T_COMPENS_BY_CHILD

--    --
DECLARE @T_COMPENS_SMETA TABLE 
	(
	LINK_CB	INT,
	VAL_SMETA	NUMERIC (10,2),
	DATE_BEGIN	DATETIME
	)

INSERT INTO @T_COMPENS_SMETA  
	(
	LINK_CB,
	VAL_SMETA,
	DATE_BEGIN
	)
SELECT
	LINK_CB,
	VAL_SMETA,
	MIN (DATE_BEGIN)
FROM @T_COMPENS_BY_CHILD
GROUP BY
	LINK_CB,
	VAL_SMETA
	
--select '@T_COMPENS_SMETA', * from @T_COMPENS_SMETA

-- dbo.PF_COMPENSATIONS --
INSERT INTO dbo.PF_COMPENSATIONS
	(
	CODE,
	NAME,
	ROUNDING,
	ROUNDING_WAY,
	LINK_DEP,
	VAL_SMETA
	)
OUTPUT INSERTED.LINK, INSERTED.LINK_DEP, INSERTED.VAL_SMETA
	INTO {Variable_TempDb}.dbo.[__PF_COMPENSATIONS_FROM_SMETA_KS]
SELECT
	CODE	=	REPLACE (CAST (T1.VAL_SMETA AS VARCHAR (10)), '.', '_'),
	NAME	=	' ' + CAST (T1.VAL_SMETA AS VARCHAR (10)) + '%',
	ROUNDING	=	1,
	ROUNDING_WAY	=	1,
	LINK_DEP	=	T1.LINK_CB,
	T1.VAL_SMETA
FROM @T_COMPENS_SMETA T1
WHERE NOT EXISTS
	(
	SELECT 1
	FROM {Variable_TempDb}.[dbo].[__PF_COMPENSATIONS_FROM_SMETA_KS] TTT
	WHERE
		TTT.[DEP_CB] = T1.LINK_CB
		AND TTT.VAL_SMETA = T1.VAL_SMETA
	)

-- dbo.PF_COMPENSATIONS_TABLE --
INSERT INTO dbo.PF_COMPENSATIONS_TABLE
	(
	LINK_UP,
	[DATE],
	[PERCENT]
	)
SELECT
	LINK_UP	=	T1.LINK,
	[DATE]	=	ISNULL (T3.DATE_BEGIN, '19900101'),
	[PERCENT]	=	T2.VAL_SMETA
FROM dbo.PF_COMPENSATIONS T1
INNER JOIN {Variable_TempDb}.[dbo].[__PF_COMPENSATIONS_FROM_SMETA_KS] T2 ON (T2.LINK = T1.LINK)
INNER JOIN @T_COMPENS_SMETA T3 ON 
	(
	T3.VAL_SMETA = T2.VAL_SMETA
	AND T3.LINK_CB = T2.DEP_CB
	)
WHERE NOT EXISTS
	(
	SELECT 1
	FROM dbo.PF_COMPENSATIONS_TABLE TTT
	WHERE TTT.LINK_UP = T1.LINK
	)

-- dbo.PF_SERVICE_REC_COMPENS --
INSERT INTO dbo.PF_SERVICE_REC_COMPENS 
	(
	LINK_UP,
	DATE_BEG,
	DATE_END,
	COMPENS,
	KOR_ACC_LINK
	)
SELECT
	LINK_UP = T1.LINK,
	DATE_BEG	=	T2.DATE_BEGIN,
	DATE_END	=	NULL,
	COMPENS		=	T4.LINK,
	KOR_ACC_LINK	=	NULL
FROM dbo.PF_SERVICE_REC T1
INNER JOIN dbo.DEPARTMENT_ACCOUNTS DEP_ACC ON (DEP_ACC.LINK = T1.DEP_ACC)
INNER JOIN @T_COMPENS_BY_CHILD T2 ON (T2.DEP_CHILD = DEP_ACC.LINK_UP)

INNER JOIN {Variable_TempDb}.dbo.[__PF_COMPENSATIONS_FROM_SMETA_KS] T3 ON
	(
	T3.VAL_SMETA = T2.VAL_SMETA
	AND T3.DEP_CB = T2.LINK_CB
	)
INNER JOIN dbo.PF_COMPENSATIONS T4 ON (T4.LINK = T3.LINK)
WHERE NOT EXISTS
	(
	SELECT 1
	FROM dbo.PF_SERVICE_REC_COMPENS TTT
	WHERE TTT.LINK_UP = T1.LINK
		AND TTT.COMPENS = T4.LINK
	)
		
GO

IF Exists(select 1 from sys.columns where Name = N'VAL_SMETA' and Object_ID = Object_ID(N'[dbo].PF_BENEFIT'))
   ALTER TABLE [dbo].PF_BENEFIT DROP COLUMN [VAL_SMETA]
GO

IF Exists(select 1 from sys.columns where Name = N'VAL_SMETA' and Object_ID = Object_ID(N'[dbo].PF_COMPENSATIONS'))
   ALTER TABLE [dbo].PF_COMPENSATIONS DROP COLUMN [VAL_SMETA]
GO

COMMIT TRAN

